// AI1216Dg.cpp : implementation file
//

#include "stdafx.h"
#include "PAI1216.h"
#include "AI1216Dg.h"

#include "AIOWDM.h"  //WDM Driver

#define InsCR(x) x += 0x0d; x += 0x0a;

bool                RunFlag, Testing;
const char          *Cards = "PCI-AI12-16";
CString				*VoltsDisplay[16], *CountsDisplay[16];

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//---------------------------------------------------------------------------
void CPAI1216Dlg::CtrMode(char cntr, char mode)
{
  RelOutPortB(CardNum, Offset + 8 + 3, (cntr << 6) | 0x30 | (mode << 1));
}
//---------------------------------------------------------------------------
void CPAI1216Dlg::CtrLoad(int c,int val)
{
  RelOutPortB(CardNum, Offset + 8 + c,val & 0x00FF);
  RelOutPortB(CardNum, Offset + 8 + c,(val>>8) & 0x00FF);
}
/////////////////////////////////////////////////////////////////////////////
// CPAI1216Dlg dialog

CPAI1216Dlg::CPAI1216Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPAI1216Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPAI1216Dlg)
	m_Channel1 = _T("");
	m_Channel10 = _T("");
	m_Channel11 = _T("");
	m_Channel12 = _T("");
	m_Channel13 = _T("");
	m_Channel14 = _T("");
	m_Channel15 = _T("");
	m_Channel16 = _T("");
	m_Channel2 = _T("");
	m_Channel3 = _T("");
	m_Channel4 = _T("");
	m_Channel5 = _T("");
	m_Channel6 = _T("");
	m_Channel7 = _T("");
	m_Channel8 = _T("");
	m_Channel9 = _T("");
	m_Status = _T("");
	m_Channel0 = _T("");
	m_Channel17 = _T("");
	m_Channel18 = _T("");
	m_Channel19 = _T("");
	m_Channel20 = _T("");
	m_Channel21 = _T("");
	m_Channel22 = _T("");
	m_Channel23 = _T("");
	m_Channel24 = _T("");
	m_Channel25 = _T("");
	m_Channel26 = _T("");
	m_Channel27 = _T("");
	m_Channel28 = _T("");
	m_Channel29 = _T("");
	m_Channel30 = _T("");
	m_Channel31 = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	VoltsDisplay[0] = &m_Channel0;
	VoltsDisplay[1] = &m_Channel1;
	VoltsDisplay[2] = &m_Channel2;
	VoltsDisplay[3] = &m_Channel3;
	VoltsDisplay[4] = &m_Channel4;
	VoltsDisplay[5] = &m_Channel5;
	VoltsDisplay[6] = &m_Channel6;
	VoltsDisplay[7] = &m_Channel7;
	VoltsDisplay[8] = &m_Channel8;
	VoltsDisplay[9] = &m_Channel9;
	VoltsDisplay[10] = &m_Channel10;
	VoltsDisplay[11] = &m_Channel11;
	VoltsDisplay[12] = &m_Channel12;
	VoltsDisplay[13] = &m_Channel13;
	VoltsDisplay[14] = &m_Channel14;
	VoltsDisplay[15] = &m_Channel15;
	CountsDisplay[0] = &m_Channel16;
	CountsDisplay[1] = &m_Channel17;
	CountsDisplay[2] = &m_Channel18;
	CountsDisplay[3] = &m_Channel19;
	CountsDisplay[4] = &m_Channel20;
	CountsDisplay[5] = &m_Channel21;
	CountsDisplay[6] = &m_Channel22;
	CountsDisplay[7] = &m_Channel23;
	CountsDisplay[8] = &m_Channel24;
	CountsDisplay[9] = &m_Channel25;
	CountsDisplay[10] = &m_Channel26;
	CountsDisplay[11] = &m_Channel27;
	CountsDisplay[12] = &m_Channel28;
	CountsDisplay[13] = &m_Channel29;
	CountsDisplay[14] = &m_Channel30;
	CountsDisplay[15] = &m_Channel31;
	m_CardName = _T("");
}

void CPAI1216Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPAI1216Dlg)
	DDX_Control(pDX, IDOK, m_DataButton);
	DDX_Control(pDX, IDC_STATUS, m_StatusControl);
	DDX_Control(pDX, IDC_CHANNELCOMBO, m_ChannelCombo);
	DDX_Text(pDX, IDC_CHANNEL1, m_Channel1);
	DDX_Text(pDX, IDC_CHANNEL10, m_Channel10);
	DDX_Text(pDX, IDC_CHANNEL11, m_Channel11);
	DDX_Text(pDX, IDC_CHANNEL12, m_Channel12);
	DDX_Text(pDX, IDC_CHANNEL13, m_Channel13);
	DDX_Text(pDX, IDC_CHANNEL14, m_Channel14);
	DDX_Text(pDX, IDC_CHANNEL15, m_Channel15);
	DDX_Text(pDX, IDC_CHANNEL16, m_Channel16);
	DDX_Text(pDX, IDC_CHANNEL2, m_Channel2);
	DDX_Text(pDX, IDC_CHANNEL3, m_Channel3);
	DDX_Text(pDX, IDC_CHANNEL4, m_Channel4);
	DDX_Text(pDX, IDC_CHANNEL5, m_Channel5);
	DDX_Text(pDX, IDC_CHANNEL6, m_Channel6);
	DDX_Text(pDX, IDC_CHANNEL7, m_Channel7);
	DDX_Text(pDX, IDC_CHANNEL8, m_Channel8);
	DDX_Text(pDX, IDC_CHANNEL9, m_Channel9);
	DDX_Text(pDX, IDC_STATUS, m_Status);
	DDX_Text(pDX, IDC_CHANNEL0, m_Channel0);
	DDX_Text(pDX, IDC_CHANNEL17, m_Channel17);
	DDX_Text(pDX, IDC_CHANNEL18, m_Channel18);
	DDX_Text(pDX, IDC_CHANNEL19, m_Channel19);
	DDX_Text(pDX, IDC_CHANNEL20, m_Channel20);
	DDX_Text(pDX, IDC_CHANNEL21, m_Channel21);
	DDX_Text(pDX, IDC_CHANNEL22, m_Channel22);
	DDX_Text(pDX, IDC_CHANNEL23, m_Channel23);
	DDX_Text(pDX, IDC_CHANNEL24, m_Channel24);
	DDX_Text(pDX, IDC_CHANNEL25, m_Channel25);
	DDX_Text(pDX, IDC_CHANNEL26, m_Channel26);
	DDX_Text(pDX, IDC_CHANNEL27, m_Channel27);
	DDX_Text(pDX, IDC_CHANNEL28, m_Channel28);
	DDX_Text(pDX, IDC_CHANNEL29, m_Channel29);
	DDX_Text(pDX, IDC_CHANNEL30, m_Channel30);
	DDX_Text(pDX, IDC_CHANNEL31, m_Channel31);
	//}}AFX_DATA_MAP
	DDX_Text(pDX, IDC_STATIC_CARD_NAME, m_CardName);
}

BEGIN_MESSAGE_MAP(CPAI1216Dlg, CDialog)
	//{{AFX_MSG_MAP(CPAI1216Dlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDCANCEL, OnExit)
	ON_BN_CLICKED(IDOK, OnGetData)
	ON_WM_SHOWWINDOW()
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPAI1216Dlg message handlers

BOOL CPAI1216Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

   if (InPortB(0x61) == 0xAA55) {
      MessageBox("ACCESNT.SYS not detected. Please copy ACCESNT.SYS into [NT]/system32/drivers and re-run this sample.", "Warning", MB_OK);
   }
	
	// TODO: Add extra initialization here
	FindCardsWDM();

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CPAI1216Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CPAI1216Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}
//---------------------------------------------------------------------------
void CPAI1216Dlg::OnExit() 
{
	exit(0);	
}
//---------------------------------------------------------------------------
void CPAI1216Dlg::OnGetData() 
{
    if (!RunFlag)
	{
        m_Status += "Cannot run without card!\r\n";
		UpdateData(false);
		m_StatusControl.LineScroll(999);
	}
	else if (Testing)
	{
		Testing = false;
		m_DataButton.SetWindowText("&Get Data");
		KillTimer(0);
	}
	else
	{
		Testing = true;
		m_DataButton.SetWindowText("&Stop Data");
		SetTimer(0, 250, NULL);
	}
}
//---------------------------------------------------------------------------
void CPAI1216Dlg::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	CDialog::OnShowWindow(bShow, nStatus);
	
	m_ChannelCombo.SetCurSel(0);
}
//---------------------------------------------------------------------------
void CPAI1216Dlg::Fifo()
{
    unsigned char chan, numchan;
    unsigned short Value;
    short counts;
    double volts;
	char text[255];

    numchan = m_ChannelCombo.GetCurSel() == 0 ? 8 : 16;
    ResetFifos();//clear channel and data fifos
    SetFifoChannels();

    CtrMode(1, 2);
    CtrLoad(1, 0x2);
    CtrMode(2, 2);
    CtrLoad(2, 0xFF);
    EnableCounters();//conversions started once counters are enabled
    CheckFifo(); //check fifo bit to see if it's half full
    DisableCounters();//stop conversions
    while((RelInPortB(CardNum, Offset + 4) & 0x02) == 0x02) //bit goes low when fifo is empty
    {
        Value = RelInPort(CardNum, Offset);
        counts = Value & 0xFFF;
        if (counts > 0x7FF)
            counts |= 0xF000;
        chan = Value >> 12;
        volts = 20.0 * (counts / 4095.0);//convert to volts: counts*max volt span/max counts
        if (chan >= numchan)
        {
			*(VoltsDisplay[chan]) = "";
			*(CountsDisplay[chan]) = "";
        }
        else
        {
			sprintf_s(text, "%2.2f", volts);
			*(VoltsDisplay[chan]) = text;
			sprintf_s(text, "%d", counts);
			*(CountsDisplay[chan]) = text;
        }
    }
	UpdateData(false);
}
//---------------------------------------------------------------------------
void CPAI1216Dlg::NoFifo()
{
    unsigned char chan, numchan;
    short counts;
    double volts;
	char text[255];

	DisableCounters();
    numchan = m_ChannelCombo.GetCurSel() == 0 ? 8 : 16;
    for (chan = 0; chan < 16; chan++)
    {
		if (chan >= numchan)
		{
			*(VoltsDisplay[chan]) = "";
			*(CountsDisplay[chan]) = "";
		}
		else
		{
			SetChannel(chan, m_ChannelCombo.GetCurSel() == 0); // write channel, range, SE or diff
			unsigned long Ticks = GetTickCount();
			while (Ticks + 2 > GetTickCount());
			StartConversion();  // start conversion
			if (WaitForEOC() == 0)   //WAITFOREOC returns zero if it times out
			{
				m_Status += "A/D Timed Out\r\n";
			}
			else
			{
				counts = (short)((short)((short)(RetrieveADConversion()<<4)))>>4; //sign extend result
				volts = (counts * 20.0)/4095.0; //convert to volts: counts*max volt span/max counts
				sprintf_s(text, "%2.2f", volts);
				*(VoltsDisplay[chan]) = text;
				sprintf_s(text, "%d", counts);
				*(CountsDisplay[chan]) = text;
			}
		}
    }
	UpdateData(false);
}
//---------------------------------------------------------------------------
void CPAI1216Dlg::SetChannel(unsigned char channel, bool DIFF_SE)
{
	char value = channel << 4;
	if (DIFF_SE) value |= 0x08;
  RelOutPortB(CardNum, Offset + 2, value); //channel selected in upper nibble at base+2
											   // and single-ended	
}
//---------------------------------------------------------------------------
void CPAI1216Dlg::StartConversion()
{
  RelOutPortB(CardNum, 0, 0); //write anything to base+0 to start conversion
}
//---------------------------------------------------------------------------
unsigned short CPAI1216Dlg::WaitForEOC()
{
  unsigned short timeout=0xFFFF;
  while(((RelInPortB(CardNum, Offset + 4) & 0x80) == 0) && timeout--);
  return timeout; //0==error
}
//---------------------------------------------------------------------------
short CPAI1216Dlg::RetrieveADConversion()
{
  return (RelInPort(CardNum, Offset + 0 & 0x0FFF));//mask upper nibble;
}
//---------------------------------------------------------------------------
void CPAI1216Dlg::CheckFifo()
{
  while((RelInPortB(CardNum, Offset + 4) & 0x04) == 0x04); // bit goes low when fifo half full
}
//---------------------------------------------------------------------------
void CPAI1216Dlg::ResetFifos()
{
  RelOutPortB(CardNum, Offset + 4, 0x48);//0x40 resets channel fifo, 0x08 resets data fifo
  for (int i=0; i<1024; i++)
    RelInPortB(CardNum,Offset);
  RelInPortB(CardNum, Offset + 6);
}
//---------------------------------------------------------------------------
void CPAI1216Dlg::SetFifoChannels()
{
  RelOutPort(CardNum, Offset + 2, 0x0000);
  RelOutPort(CardNum, Offset + 2, 0x1010);
  RelOutPort(CardNum, Offset + 2, 0x2020);
  RelOutPort(CardNum, Offset + 2, 0x3030);
  RelOutPort(CardNum, Offset + 2, 0x4040);
  RelOutPort(CardNum, Offset + 2, 0x5050);
  RelOutPort(CardNum, Offset + 2, 0x6060);
  RelOutPort(CardNum, Offset + 2, 0x7070);
  RelOutPort(CardNum, Offset + 2, 0x8080);
  RelOutPort(CardNum, Offset + 2, 0x9090);
  RelOutPort(CardNum, Offset + 2, 0xA0A0);
  RelOutPort(CardNum, Offset + 2, 0xB0B0);
  RelOutPort(CardNum, Offset + 2, 0xC0C0);
  RelOutPort(CardNum, Offset + 2, 0xD0D0);
  RelOutPort(CardNum, Offset + 2, 0xE0E0);
  RelOutPort(CardNum, Offset + 2, 0xF0F0);
  
  RelInPort(CardNum, Offset + 2);
}
//---------------------------------------------------------------------------
void CPAI1216Dlg::EnableCounters()
{
  RelOutPortB(CardNum, Offset + 4, 0x01); //set counter enable bit, starts conversions
}
//---------------------------------------------------------------------------
void CPAI1216Dlg::DisableCounters()
{
  RelOutPortB(CardNum, Offset + 4, 0); //set counter enable bit, starts conversions
}
//----------------------------------------------------------------------------
void CPAI1216Dlg::OnTimer(UINT nIDEvent) 
{
	UpdateData(true);

	if (UseFIFO)
		Fifo();
	else
		NoFifo();
	
	CDialog::OnTimer(nIDEvent);
}
//----------------------------------------------------------------------------
void CPAI1216Dlg::FindCardsWDM(void)
{
	bool found = false;
	
	// Vars for QueryCardInfo() :
    unsigned long DeviceID, Base;
    unsigned long NameSize;
    UCHAR Name[256];
	CString strname;

	// Init:
    RunFlag = true;
	NumCards = 0;
	CardNum = 0;
	int DataIndex = 0;
	Offset =0;

	// Set CardData to 0 as needed:
    CardData.IsValid = false;
    CardData.IsSelected = false;
    CardData.DeviceID = 0;
    CardData.Base = 0;	  		
	

	// Get the total number of cards installed:
	NumCards = GetNumCards();
	
	if (NumCards == 0) // no cards present
	{	    		
		m_CardName = "No Card Found";

		m_Status =  "No cards were found!";
		m_Status += "This may mean the card is not installed. ";
		m_Status += "Check Device Manager for a card and its status";
		m_Status += "You may consider rebooting your system.";
		m_StatusControl.LineScroll(999);

		RunFlag = false;
	}
	else 
	{
		// validate and store card data:
		NameSize = 256;
		QueryCardInfo(CardNum, &DeviceID, &Base, &NameSize, Name);
						
		// only need to do this once:
		CardData.DeviceID = DeviceID;
		CardData.Base = Base;
		CardData.IsValid = true;

		// Populate GUI set flags:
		switch (DeviceID) 
		{
			// The Model -A cards have FIFO's   vendor id: 0x494F
			case 0xECA9: // PCIA1216
            case 0xECAA: // PCIA1216A  FIFO
                UseFIFO = ( (DeviceID == 0xECA9) ? 0 : 1 );

			case 0xACA8: // PCIAI1216
			case 0xACA9: // PCIAI1216A FIFO
				m_CardName = Name; // "PCI-A12-16 Analog I/O Card with Digital";
				found = true;
                UseFIFO = ( (DeviceID == 0xACA8) ? 0 : 1 );
				break;

			default:
				break;
		}//end switch			
	}//end else card present

	// If card(s) are present but no valid cards were found:
	if ((NumCards != 0) && (found == false) ) 
	{	    		
		m_CardName = "No Valid Card Found.";

		m_Status =  "No valid card was found!";
		m_Status += "This may mean the card is not installed. ";
		m_Status += "Check Device Manager for a card and its status";
		m_Status += "You may consider rebooting your system.";
		m_StatusControl.LineScroll(999);

		RunFlag = false;
	}

   UpdateData(false);

   if (RunFlag) 
   {
      UpdateData(true);
	  
	  // This is the result setting the active address offset to be used and flag:	  
	  Offset = 0;  //default to fist valid
	  CardData.IsSelected = true;
   }

}
