// AI1216Dg.h : header file
//

#if !defined(AFX_PAI1216DLG_H__7F8EE4E7_75C5_11D2_91DE_00A0C970A3E8__INCLUDED_)
#define AFX_PAI1216DLG_H__7F8EE4E7_75C5_11D2_91DE_00A0C970A3E8__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

/////////////////////////////////////////////////////////////////////////////
// CPAI1216Dlg dialog

class CPAI1216Dlg : public CDialog
{
// Construction
public:
	CPAI1216Dlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CPAI1216Dlg)
	enum { IDD = IDD_PAI1216_DIALOG };
	CButton	m_DataButton;
	CEdit	m_StatusControl;
	CComboBox	m_ChannelCombo;
	CString	m_CardLabel;
	CString	m_Channel1;
	CString	m_Channel10;
	CString	m_Channel11;
	CString	m_Channel12;
	CString	m_Channel13;
	CString	m_Channel14;
	CString	m_Channel15;
	CString	m_Channel16;
	CString	m_Channel2;
	CString	m_Channel3;
	CString	m_Channel4;
	CString	m_Channel5;
	CString	m_Channel6;
	CString	m_Channel7;
	CString	m_Channel8;
	CString	m_Channel9;
	CString	m_Status;
	CString	m_Channel0;
	CString	m_Channel17;
	CString	m_Channel18;
	CString	m_Channel19;
	CString	m_Channel20;
	CString	m_Channel21;
	CString	m_Channel22;
	CString	m_Channel23;
	CString	m_Channel24;
	CString	m_Channel25;
	CString	m_Channel26;
	CString	m_Channel27;
	CString	m_Channel28;
	CString	m_Channel29;
	CString	m_Channel30;
	CString	m_Channel31;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CPAI1216Dlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation

	long NumCards;					// Number of cards found 1
	long CardNum;					// Number of the card found 0
	unsigned long Offset;			// This the result of findcards and the address offset used
    int UseFIFO;
	bool RunFlag;
	unsigned long BaseOffset[5];

	struct TCardData 
	{
		bool IsValid; 
		bool IsSelected; 
		unsigned long DeviceID; 
		unsigned long Base;
	};

	TCardData CardData; // only set up for 1 here	
	
	void CPAI1216Dlg::CtrMode(char cntr, char mode);
	void CPAI1216Dlg::CtrLoad(int c,int val);

	void FindCardsWDM(void);
    void NoFifo();
	void SetChannel(unsigned char channel, bool DIFF_SE);
    void StartConversion();
    unsigned short WaitForEOC();
    short RetrieveADConversion();
    void EnableCounters();
    void DisableCounters();
	void ResetFifos();
	void SetFifoChannels();
	void Fifo();
	void CheckFifo();

protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CPAI1216Dlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnExit();
	afx_msg void OnGetData();
	afx_msg void OnShowWindow(BOOL bShow, UINT nStatus);
	afx_msg void OnTimer(UINT nIDEvent);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
public:
	CString m_CardName;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PAI1216DLG_H__7F8EE4E7_75C5_11D2_91DE_00A0C970A3E8__INCLUDED_)
